/*
 * Copy all data from an ibmpc diskett (40 tracks, dual side, 9 sektors)
 * to a specified file.
 *
 * By JaDa, 1-Oct-1987
 */

#include <stdio.h>
#include <fcntl.h>
#define L_SET 0			/* from file.h on BSD4.3 */

#define MFDEV    "/dev/mf2-512"
#define OUTFILE  argv[1]


#define CYLSIZE  (512*9*2)
char buffer[CYLSIZE];		/* get one cyl at a time */



int
copyit(ind, outd)
    int ind;
    int outd;
{
    long position = 0;
    int cylcount = 40;

    do {

	if (lseek(ind, position, L_SET) != position) {
	    perror("lseek on input failed");
	    return 1;
	}

	if (read(ind, buffer, CYLSIZE) != CYLSIZE) {
	    perror("read failed");
	    return 1;
	}

	if (write(outd, buffer, CYLSIZE) != CYLSIZE) {
	    perror("write failed");
	    return 1;
	}

	position += (2 * CYLSIZE);

    } while (--cylcount > 0);

    return 0;
}




int
main(argc, argv)
    int argc;
    char **argv;
{
    int ind, outd, s;

    if (argc != 2) {
	fprintf(stderr,
	    "Usage: %s <filename>  ( copy ibm disk in mf2-512 to file )\n",
	    *argv);
	exit(1);
    }

    ind = open(MFDEV, O_RDONLY, 0);
    if (ind < 0) {
	fprintf(stderr, "Can't open %s : ", MFDEV);
	perror("");
	exit(1);
    }

    outd = open(OUTFILE, O_WRONLY | O_CREAT, 0666);
    if (outd < 0) {
	close(ind);
	fprintf(stderr, "Can't open %s : ", OUTFILE);
	perror("");
	exit(1);
    }

    s = copyit(ind, outd);

    close(ind);
    close(outd);

    exit(s);
}

