#include <stdio.h>
#include <fcntl.h>

#define WS (1)		/* write this many chars each time ... */
char buffer[32768*4];

#define TDEV tracef
#define TP(z) {fprintf/**/z;fflush(TDEV);}
#define TW {char ch[8];read(fileno(TDEV),ch,8);}

char *mknp();

main(argc, argv)
    int argc;
    char **argv;
{
    FILE *tracef;

    if (argc != 2) {
	fprintf(stderr, "Usage: %s <filename>\n", argv[0]);
	exit(1);
    }

    tracef = fopen("/dev/tty03", "r+");
    if (tracef == NULL) {
	perror("Can't open traceoutput");
    }
    TP((TDEV, "%s", "\r\nStarting...\n"))

    {
	char *p;
	int count = 0, n;
	int fp = open(argv[1], O_RDONLY, 0);

	if (fp < 0) {
	    fprintf(stderr, "Can't open file %s : ", argv[1]);
	    perror("");
	    exit(1);
	}

	count = read(fp, buffer, sizeof(buffer));

	if (count <= 0) {
	    if (count < 0) {
		fprintf(stderr, "Error reading file %s : ", argv[1]);
		perror("");
		exit(1);
	    }
	    fprintf(stderr, "file %s is empty !!\n");
	    exit(1);
	}

	close(fp);

	p = buffer;

	while (count > 0) {
	    int n = WS;

	    if (count >= WS) {
		n = WS;
	    } else {
		n = count;
	    }

	    TP((TDEV, "%s", mknp(p, n)))
	    TW

	    write(1, p, n);
	    p += n;
	    count -= n;
	}
    }

    exit(0);
}



char *
mknp(p, n)
    char *p;
    int n;
{
    static unsigned char buff[1024];
    register unsigned char *pin = (unsigned char *) p;
    register unsigned char *pout = buff;
    register int cnt = n;

    while (cnt-- > 0) {			/* NOTE!!! no buff overflow check */
	register int ch = (int) *pin++;
	if (ch & 0x80) {
	    *pout++ = 'M';
	    *pout++ = '-';
	    ch &= 0x7F;
	}
	if (ch < ' ') {
	    *pout++ = '^';
	    *pout++ = ch + '@';
	} else if (ch == 0x7F) {
	    *pout++ = '^';
	    *pout++ = '?';
	} else {
	    *pout++ = ch;
	}
    }

    *pout = '\000';

    return (char *) &buff[0];
}

