#include <stdio.h>
#include <fcntl.h>

#define L_SET 0			/* set absolute position of file pointer */

#define DEVICENAME "/dev/mf2"
#define BLKSIZE    16384

main(argc, argv)
    int argc;
    char ** argv;
{
    int blocksize = BLKSIZE;
    int fp;
    int block = -1;
    int maxerr = 3;
    char pathname[256], *devicename;
    unsigned char buffer[BLKSIZE];

    strcpy(pathname, DEVICENAME);
    if (argc > 1) {
	char *p = argv[1];
	if (*p++ == '-'  &&  *p++ == 'b') {
	    int val;
	    if (sscanf(p, "%d", &val) == 1) {
		if (val > 0  &&  val <= BLKSIZE) {
		    blocksize = val;
		} else {
		    fprintf(stderr, "Invalid block size (0...%d)\n", BLKSIZE);
		    exit(1);
		}
	    }
	    if (argc > 2) {
		strcpy(pathname, argv[2]);
	    }
	} else {
	    strcpy(pathname, argv[1]);
	}
    }

    devicename = pathname;

    if ((fp = open(devicename, O_RDONLY, 0)) < 0) {
	fprintf(stderr, "%s : Can't open file : ", devicename);
	perror("");
	exit(1);
    }

    while (maxerr > 0) {
	long bpos = ++block * blocksize;

	if (lseek(fp, bpos, L_SET) != bpos) {
	    fprintf(stderr, "%s : lseek(,%ld,) failed : ", devicename, bpos);
	    perror("");
	    maxerr--;
	    continue;
	}

	if (read(fp, buffer, blocksize) != blocksize) {
	    fprintf(stderr, "%s : read blk %d failed : ", devicename, block);
	    perror("");
	    maxerr--;
	    continue;
	}
    }

    exit(0);
}

