#include <stdio.h>
#include <termio.h>
#include <fcntl.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <sys/lock.h>

#define DELAY		10	/* tenths of seconds to wait */
#define TIMEOUTV	100	/* wait if char count is lower then this */
#define EXPECTED	255


#define SEGSIZE		8192L
#define SD_WRITE	0
#define SD_CREAT	0



plock(n)
{
    return 0;
}


/*
 * Shared memory buffer structure
 */

char *dummy_pointer;
int  dummy_int;

struct buffer {
    char *begin;
    char *end;
    char *inp;
    char *outp;
    int  count;
    int  bsize;
    int  tracemode;
    /*char buffer[SEGSIZE - 24];*/
    char buffer[(SEGSIZE - 4*sizeof(dummy_pointer) - 4*sizeof(dummy_int))];
};



/* Some defines for traceprinting... */

#define TPinit(z) trace_init(z);
#define TDEV  fptty03
#define TP(z) if(bp->tracemode&1){fprintf/**/z;fflush(TDEV);}	/**/
#define TP2(z) if(bp->tracemode&2){fprintf/**/z;fflush(TDEV);sleep(1);}	/**/
#define TP3(z) if(bp->tracemode&4){fprintf/**/z;fflush(TDEV);}	/**/

long totcount = 0;
FILE *fptty03 = stderr;

trace_init(bp)
    struct buffer *bp;
{
    FILE *p = fopen("/dev/tty03", "w");
    if (p == NULL) {
	perror("\r\nCan't open traceoutput /dev/tty03");
	return;
    }
    fptty03 = p;
    TP((TDEV, "%s: Trace 1 active\n", "filt"))
    TP2((TDEV, "%s: Trace 2 active\n", "filt"))
    return;
}



long counts[EXPECTED+6];
int  goon = 1;


/*------------------------------------------------------------
 * Some code to handle semafores...
 */

struct sembuf semopb;
int semid = -1;

semread()
{
    int n;
    if ((n = semctl(semid, 0, GETVAL, 0)) < 0) {
	perror("semread: segctl call failed");
	return -1;
    }
    return n;
}

semsignal(n)	/* n > 0 */
    int n;
{
    int stat;
    semopb.sem_op = n;
    if ((stat = semop(semid, &semopb, 1)) < 0) {
	perror("semsignal: semop call failed");
	return -1;	/**/
    }
/*if (stat > 0) fprintf(stderr, "\r\nsemsignal: semop returned %d  ", stat); /**/
    return 0;
}

semwait(n)	/* n > 0 */
    int n;
{
    int stat;
    semopb.sem_op = -n;
    if ((stat = semop(semid, &semopb, 1)) < 0) {
	perror("semwait: semop call failed");
	return -1;
    }
/*if (stat > 0) fprintf(stderr, "\r\nsemwait: semop returned %d  ", stat);/**/
    return 0;
}


seminit()
{
    union semun { int val; struct semid_ds *buf; ushort *array; } arg;
    semid = semget(43, 1, 0666 | IPC_CREAT);
    if (semid < 0) {
	perror("semget call failed");
	return -1;
    }
    arg.val = 0;
    if (semctl(semid, 0, SETVAL, arg)) {
	perror("segctl call failed");
	return -1;
    }
    semopb.sem_num = 0;
    semopb.sem_flg = 0;
    return 0;
}


/*------------------------------------------------------------
 * The main routine.
 */


main(argc, argv)
    int argc;
    char **argv;
{
    int tty02,
        ttyout = 1, /* stdout */
        ttyin = 0,  /* stdin */
    	childpid,
        rcnt,
    	expected = EXPECTED;

    int sigterm_h();
    struct termio tty02s, tty02sxon, console, oconsole;

    register struct buffer *bp;

    {	/* Fix a shared memory buffer */
	key_t key;
	int shmid;
	char *segp, *shmat();
	int flag;

	key = (key_t) 43;
	/* printf("key: "); scanf("%d",&key);		/**/
	/* printf("flag: "); scanf("%x",&flag);		/**/

	shmid = shmget(key, SEGSIZE, IPC_CREAT);
	if ( shmid == -1 ) {
	    printf("Key: %d, Flag: 0x%x ",key,flag); perror("  shmget faild in child1");
	    exit(1);
	}

	segp = shmat(shmid, NULL, 0);
	if (segp == NULL) {
	    perror("  shmat failed in child1");
	    exit(1);
	}
	bp = (struct buffer *) segp;
    }

    bp->tracemode = 0;
    bp->count = 0;
    bp->bsize = sizeof(*bp) - (bp->buffer - (char*)bp);
    bp->begin = bp->buffer;
    bp->end = bp->buffer + bp->bsize;
    bp->outp = bp->buffer;
    bp->inp = bp->buffer;

    TPinit(bp)


	if ( (int)signal(SIGTERM,sigterm_h) == -1 ) {

	   perror("PANIC: signal handler setup fail");
	   exit(1);


	}

	if ( ( tty02 = open("/dev/tty02",O_RDWR,0) ) < 0 ) {

		perror("Open of tty02 fail");
		exit(1);
		
	}
	
	tty02s.c_iflag = /*IXOFF |*/ IGNBRK ;
	tty02s.c_oflag = NULL ;
	tty02s.c_cflag = B9600 | CS8 | CREAD ;
	tty02s.c_lflag = NULL ;
	tty02s.c_line  = NULL ;
	tty02s.c_cc[VINTR] = 255;
	tty02s.c_cc[VQUIT] = 255;
	tty02s.c_cc[VERASE] = 255;
	tty02s.c_cc[VKILL] = 255;
	tty02s.c_cc[VMIN] = TIMEOUTV;
	tty02s.c_cc[VTIME] = DELAY;
	tty02s.c_cc[6] = TIMEOUTV;
	tty02s.c_cc[7] = DELAY;
	
	tty02sxon = tty02s;
	tty02sxon.c_iflag |= IXOFF;
	
	if ( ioctl(tty02,TCSETA,&tty02sxon) < 0 ) {
	   perror("PANIC: cannot TCSETA fail tty02");
	   exit(1);
	}


	if ( ioctl(0,TCGETA,&oconsole) < 0 ) {
	   perror("PANIC cannot TCGETA console");
	   exit(1);
	}

	console.c_iflag = IGNBRK ;
	console.c_oflag = NULL ;
	console.c_cflag = B9600 | CS8 | CREAD ;
	console.c_lflag = NULL ;
	console.c_line  = NULL ;
	console.c_cc[VEOF] = 1;
	console.c_cc[VEOL] = 0;
	
	if ( ioctl(0,TCSETA,&console) < 0 ) {
	   perror("PANIC cannot TCSETA console");
	   exit(1);
	}

	if ( ( childpid = fork() ) == 0 ) { /* child, read remote */

	   int child2;

	   if (seminit()) exit(1);
	   printf("Child running...\r\n"); fflush(stdout);

	   if ( (child2 = fork()) == 0 ) {

	      char *buffrs, *buffre;
	      int buffrc;

	      if (plock(PROCLOCK)) perror("child2: plock failed");
	      nice(-12);

	      while (1) {

		 nice(4);		/* lower our priority */
		 /* nap(50);	/**/
		 if (semwait(1)) exit(1);	/* wait for one character */
		 nice(-4);	/**/
		 if ((buffrc = semread()) < 0) exit(1);
		 buffrc++;			/* add the char from semwait */

		 /* buffrc = bp->count;		/* number of chars in buffer */ 
		 if ((bp->outp + buffrc) >= bp->end) {
		    register int n;
		    n = bp->end - bp->outp;
		    if (n <= 0) {
		       bp->outp = bp->buffer;
		    } else {
		       buffrc = n;
		    }
		 }

		 if (buffrc > 64) buffrc = 64;	/**/


		 /* bp->count -= buffrc;	/**/

		 /* update semafore if we got more then one char */
		 if (buffrc > 1) if (semwait(buffrc - 1)) exit(1);

		 totcount += buffrc;
		 TP((TDEV, "child2: %d : got %d chars\n", totcount, buffrc))

		 if (buffrc == 0) continue;	/* nothing... */

		 TP2((TDEV, "child12: writeing %d chars.", buffrc))
		 if (bp->tracemode&4) write(fileno(TDEV), bp->outp, buffrc);
		 if (write(ttyout, bp->outp, buffrc) != buffrc) {
		    perror("\r\n-- write ttyout failed ");
		    exit(1);
		 }
		 TP2((TDEV, "%s: done\r\n", "child2"))

		 bp->outp += buffrc;
	      }
	   }

	   if (child2 < 0) {
	      perror(" fork failed in child1");
	      exit(1);
	   }

	   if ( 1 ) {

	      nice(-10);		/* we MUST be able to run... ?? */
	      if (plock(PROCLOCK)) perror("child1: plock failed");
	      /* leave lock region */

	      while (goon) {
		 char *p;
		 int n;

		 if (bp->inp >= bp->end) {
		    bp->inp = bp->buffer;
		 }

		 expected = bp->end - bp->inp;
		 if (expected > EXPECTED) expected = EXPECTED;
		 if ((n = semread()) >= 0  &&  (bp->bsize - n) < expected) {
		    /* shit... */
		    TP3((TDEV, " [buffer full, data ignored...]\r\n"))
		    continue;
		 }
		 p = bp->inp;

		 if ( ( rcnt = read(tty02, p, expected) ) < 0 ) {
		    perror("PANIC child cannot read tty02");
		    break;
		 }
                 counts[rcnt] += 1;
		 if (rcnt && (bp->tracemode&8)) write(fileno(TDEV), p, rcnt);

		 bp->inp += rcnt;
		 /* bp->count += rcnt;	/**/

		 totcount += rcnt;
		 TP((TDEV, "child1: %d : putin %d chars\n", totcount, rcnt))

		 if (rcnt > 0) if (semsignal(rcnt)) {
		    break;
		 }
	      }

	      kill(child2, 9);
	      exit(0);

	   }

	} else { /* parent, read local */

	   char chbuf[2];

	   nice(-15);
	   if (plock(PROCLOCK)) perror("master: plock failed");
	   printf("Parent running...\r\n"); fflush(stdout);

	   while ( 1 ) {

	      if ( read(ttyin,chbuf,1) != 1 ) {
	      
	         perror("PANIC parent cannot read ttyin");
		 break;
		 
	      }

	      if ( *chbuf == '\034' ) {

		 if ( read(ttyin,chbuf,1) != 1 ) {
		    perror("PANIC parent cannot read ttyin");
		    break;
		 }

		 if (*chbuf == 3) break;			/* ^C */

		 if (*chbuf == 1) {				/* ^A */
		    if ( ioctl(tty02,TCSETA,&tty02s) < 0 ) {
		       perror("\r\nTCSETA fail on tty02");
		    }
		    continue;
		 }
		 if (*chbuf == 0x10) {				/* ^P */
		    if ( ioctl(tty02,TCSETA,&tty02sxon) < 0 ) {
		       perror("\r\nTCSETA fail on tty02");
		    }
		    continue;
		 }

		 if (*chbuf == '1') {
		    bp->tracemode |= 1;
		    continue;
		 }
		 if (*chbuf == '2') {
		    bp->tracemode |= 2;
		    continue;
		 }
		 if (*chbuf == '3') {
		    bp->tracemode |= 4;
		    continue;
		 }
		 if (*chbuf == '4') {
		    bp->tracemode |= 8;
		    continue;
		 }
		 if (*chbuf == 'n') {
		    bp->tracemode = 0;
		    continue;
		 }

	      }

	      if ( write(tty02,chbuf,1) != 1 ) {
	      
	         perror("PANIC parent cannot write tty02");
		 break;
		 
	      }

	   }

	   if ( kill(childpid,SIGTERM) != 0 ) {
	      perror("\r\nPANIC cannot kill child");
	   }

	   if ( ioctl(0,TCSETAW,&oconsole) < 0 ) {
	      perror("PANIC cannot TCSETAW console");
	   }

	   wait(0);
	   write(2, "\r\n", 2);
	}

	exit(0);
}


sigterm_h()
{

int i;

    for ( i = 0; i < 256; i++ ) {

	if ( counts[i] != 0 ) {

	   printf("i %d counts[i] %d\r\n",i,counts[i]);

	}

    }

    goon = 0;
}

