#include <sys/ioctl.h>
#include <fcntl.h>
#include <stdio.h>
#include <termio.h>
#include <signal.h>

#define DELAY		10	/* tenths of seconds to wait */
#define WAITLIMIT	30	/* wait if char count is lower then this */
#define EXPECTED	1023


long counts[EXPECTED +1];


main() {

int tty02,
    ttyout = 1, /* stdout */
    ttyin = 0,  /* stdin */
    childpid,
    rcnt,
    expected;

char chbuf[EXPECTED +1];

int sigterm_h();

struct termio tty02s, console, oconsole;


	if ( (int)signal(SIGTERM,sigterm_h) == -1 ) {

	   perror("PANIC: signal handler setup fail");
	   exit(1);


	}

	if ( ( tty02 = open("/dev/tty02",O_RDWR,0) ) < 0 ) {

		perror("Open of tty02 fail");
		exit(1);
		
	}
	
	tty02s.c_iflag = /**dis/ IXOFF | /**/ IGNBRK ;
	tty02s.c_oflag = NULL ;
	tty02s.c_cflag = B9600 | CS8 | CREAD ;
	tty02s.c_lflag = NULL ;
	tty02s.c_line  = NULL ;
	tty02s.c_cc[VINTR] = 255;
	tty02s.c_cc[VQUIT] = 255;
	tty02s.c_cc[VERASE] = 255;
	tty02s.c_cc[VKILL] = 255;
	tty02s.c_cc[VMIN] = WAITLIMIT;
	tty02s.c_cc[VTIME] = DELAY;
	tty02s.c_cc[6] = WAITLIMIT;
	tty02s.c_cc[7] = DELAY;
	
	
	if ( ioctl(tty02,TCSETA,&tty02s) < 0 ) {
	   perror("PANIC: cannot TCSETA fail tty02");
	   exit(1);
	}


	if ( ioctl(0,TCGETA,&oconsole) < 0 ) {
	   perror("PANIC cannot TCGETA console");
	   exit(1);
	}

	console.c_iflag = IGNBRK ;
	console.c_oflag = NULL ;
	console.c_cflag = B9600 | CS8 | CREAD ;
	console.c_lflag = NULL ;
	console.c_line  = NULL ;
	console.c_cc[VEOF] = 1;
	console.c_cc[VEOL] = 0;
	
	if ( ioctl(0,TCSETA,&console) < 0 ) {
	   perror("PANIC cannot TCSETA console");
	   exit(1);
	}

	if ( ( childpid = fork() ) == 0 ) { /* child, read remote */

	   printf("Child running...\r\n"); fflush(stdout);
	   expected = EXPECTED;

	   while (1) {

	      if ( ( rcnt = read(tty02,chbuf,expected) ) < 0 ) {

	      	 perror("PANIC child cannot read tty02");
	      	 exit(1);

	      }

	      counts[rcnt]++;

	      if (rcnt > 0) {

	         write(ttyout, chbuf, rcnt);

	      }

	   }

	} else { /* parent, read local */

	   printf("Parent running...\r\n"); fflush(stdout);

	   while ( 1 ) {

	      if ( read(ttyin,chbuf,1) != 1 ) {
	      
	         perror("PANIC parent cannot read ttyin");
		 break;
		 
	      }

	      if ( *chbuf == '\034' ) break;

	      if ( write(tty02,chbuf,1) != 1 ) {
	      
	         perror("PANIC parent cannot write tty02");
		 break;
		 
	      }

	   }

	   if ( kill(childpid,SIGTERM) != 0 ) {
	      perror("PANIC cannot kill child");
	   }

	   if ( ioctl(0,TCSETAW,&oconsole) < 0 ) {
	      perror("PANIC cannot TCSETAW console");
	   }

	   wait(0);

	}

}


sigterm_h()
{

int i;

    for ( i = 0; i < EXPECTED; i++ ) {

	if ( counts[i] != 0 ) {

	   printf("i %d counts[i] %d\n",i,counts[i]);

	}

    }

    exit(0);
}

